diff --git a/python/pystache/pystache/specloader.py b/python/pystache/pystache/specloader.py
index 3a77d4c528..a572e53460 100644
--- a/python/pystache/pystache/specloader.py
+++ b/python/pystache/pystache/specloader.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module supports customized (aka special or specified) template loading.
 
@@ -11,7 +9,7 @@ from pystache.loader import Loader
 
 
 # TODO: add test cases for this class.
-class SpecLoader(object):
+class SpecLoader:
 
     """
     Supports loading custom-specified templates (from TemplateSpec instances).
@@ -83,7 +81,7 @@ class SpecLoader(object):
 
         """
         if spec.template is not None:
-            return self.loader.unicode(spec.template, spec.template_encoding)
+            return self.loader.str(spec.template, spec.template_encoding)
 
         path = self._find(spec)
 
diff --git a/python/pystache/pystache/template_spec.py b/python/pystache/pystache/template_spec.py
index 9e9f454c19..f287961aac 100644
--- a/python/pystache/pystache/template_spec.py
+++ b/python/pystache/pystache/template_spec.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 Provides a class to customize template information on a per-view basis.
 
@@ -9,7 +7,7 @@ stands for "special" or "specified" template information.
 
 """
 
-class TemplateSpec(object):
+class TemplateSpec:
 
     """
     A mixin or interface for specifying custom template information.
diff --git a/python/pystache/setup.py b/python/pystache/setup.py
index 0d99aae8fb..83e8cd398f 100644
--- a/python/pystache/setup.py
+++ b/python/pystache/setup.py
@@ -1,5 +1,4 @@
 #!/usr/bin/env python
-# coding: utf-8
 
 """
 This script supports publishing Pystache to PyPI.
@@ -85,6 +84,7 @@ Push a tag to GitHub:
 
 """
 
+from __future__ import print_function
 import os
 import shutil
 import sys
@@ -170,7 +170,7 @@ def write(u, path):
     Write a unicode string to a file (as utf-8).
 
     """
-    print("writing to: %s" % path)
+    print(("writing to: %s" % path))
     # This function implementation was chosen to be compatible across Python 2/3.
     f = open(path, "wb")
     try:
@@ -200,7 +200,7 @@ def strip_html_comments(text):
     lines = text.splitlines(True)  # preserve line endings.
 
     # Remove HTML comments (which we only allow to take a special form).
-    new_lines = filter(lambda line: not line.startswith("<!--"), lines)
+    new_lines = [line for line in lines if not line.startswith("<!--")]
 
     return "".join(new_lines)
 
@@ -221,9 +221,9 @@ def convert_md_to_rst(md_path, rst_temp_path):
 
     """
     # Pandoc uses the UTF-8 character encoding for both input and output.
-    command = "pandoc --write=rst --output=%s %s" % (rst_temp_path, md_path)
-    print("converting with pandoc: %s to %s\n-->%s" % (md_path, rst_temp_path,
-                                                       command))
+    command = "pandoc --write=rst --output={} {}".format(rst_temp_path, md_path)
+    print(("converting with pandoc: {} to {}\n-->{}".format(md_path, rst_temp_path,
+                                                       command)))
 
     if os.path.exists(rst_temp_path):
         os.remove(rst_temp_path)
@@ -290,17 +290,17 @@ def publish():
     long_description = make_long_description()
 
     if long_description != read(RST_DESCRIPTION_PATH):
-        print("""\
-Description file not up-to-date: %s
+        print(("""\
+Description file not up-to-date: {}
 Run the following command and commit the changes--
 
-    python setup.py %s
-""" % (RST_DESCRIPTION_PATH, PREP_COMMAND))
+    python setup.py {}
+""".format(RST_DESCRIPTION_PATH, PREP_COMMAND)))
         sys.exit()
 
-    print("Description up-to-date: %s" % RST_DESCRIPTION_PATH)
+    print(("Description up-to-date: %s" % RST_DESCRIPTION_PATH))
 
-    answer = raw_input("Are you sure you want to publish to PyPI (yes/no)?")
+    answer = input("Are you sure you want to publish to PyPI (yes/no)?")
 
     if answer != "yes":
         exit("Aborted: nothing published")
@@ -365,7 +365,7 @@ def main(sys_argv):
 
     # TODO: use the logging module instead of printing.
     # TODO: include the following in a verbose mode.
-    sys.stderr.write("pystache: using: version %s of %s\n" % (repr(dist.__version__), repr(dist)))
+    sys.stderr.write("pystache: using: version {} of {}\n".format(repr(dist.__version__), repr(dist)))
 
     command = sys_argv[-1]
 
diff --git a/python/pystache/test_pystache.py b/python/pystache/test_pystache.py
index 9a1a3ca26d..dc99f06ee8 100644
--- a/python/pystache/test_pystache.py
+++ b/python/pystache/test_pystache.py
@@ -1,5 +1,4 @@
 #!/usr/bin/env python
-# coding: utf-8
 
 """
 Runs project tests.
diff --git a/python/pytest/_pytest/_code/_py2traceback.py b/python/pytest/_pytest/_code/_py2traceback.py
index a830d9899a..2661738c10 100644
--- a/python/pytest/_pytest/_code/_py2traceback.py
+++ b/python/pytest/_pytest/_code/_py2traceback.py
@@ -23,7 +23,7 @@ def format_exception_only(etype, value):
 
     # An instance should not have a meaningful value parameter, but
     # sometimes does, particularly for string exceptions, such as
-    # >>> raise string1, string2  # deprecated
+    # >>> raise string1(string2  # deprecated)
     #
     # Clear these out first because issubtype(string1, SyntaxError)
     # would throw another exception and mask the original problem.
@@ -49,7 +49,7 @@ def format_exception_only(etype, value):
         if badline is not None:
             if isinstance(badline, bytes):  # python 2 only
                 badline = badline.decode('utf-8', 'replace')
-            lines.append(u'    %s\n' % badline.strip())
+            lines.append('    %s\n' % badline.strip())
             if offset is not None:
                 caretspace = badline.rstrip('\n')[:offset].lstrip()
                 # non-space whitespace (likes tabs) must be kept for alignment
@@ -67,12 +67,12 @@ def _format_final_exc_line(etype, value):
     if value is None or not valuestr:
         line = "%s\n" % etype
     else:
-        line = "%s: %s\n" % (etype, valuestr)
+        line = "{}: {}\n".format(etype, valuestr)
     return line
 
 def _some_str(value):
     try:
-        return unicode(value)
+        return str(value)
     except Exception:
         try:
             return str(value)
diff --git a/python/pytest/_pytest/_code/code.py b/python/pytest/_pytest/_code/code.py
index 8995cc1f71..1f0b3bd355 100644
--- a/python/pytest/_pytest/_code/code.py
+++ b/python/pytest/_pytest/_code/code.py
@@ -7,12 +7,9 @@ builtin_repr = repr
 
 reprlib = py.builtin._tryimport('repr', 'reprlib')
 
-if sys.version_info[0] >= 3:
-    from traceback import format_exception_only
-else:
-    from ._py2traceback import format_exception_only
+from traceback import format_exception_only
 
-class Code(object):
+class Code:
     """ wrapper around Python code objects """
     def __init__(self, rawcode):
         if not hasattr(rawcode, "co_filename"):
@@ -72,7 +69,7 @@ class Code(object):
             argcount += raw.co_flags & CO_VARKEYWORDS
         return raw.co_varnames[:argcount]
 
-class Frame(object):
+class Frame:
     """Wrapper around a Python frame holding f_locals and f_globals
     in which expressions can be evaluated."""
 
@@ -133,7 +130,7 @@ class Frame(object):
                 pass     # this can occur when using Psyco
         return retval
 
-class TracebackEntry(object):
+class TracebackEntry:
     """ a single entry in a traceback """
 
     _repr_style = None
@@ -182,7 +179,7 @@ class TracebackEntry(object):
             source = py.builtin._totext(self.statement).strip()
             x = reinterpret(source, self.frame, should_fail=True)
             if not py.builtin._istext(x):
-                raise TypeError("interpret returned non-string %r" % (x,))
+                raise TypeError("interpret returned non-string {!r}".format(x))
             self.exprinfo = x
         return self.exprinfo
 
@@ -286,7 +283,7 @@ class Traceback(list):
         return self
 
     def __getitem__(self, key):
-        val = super(Traceback, self).__getitem__(key)
+        val = super().__getitem__(key)
         if isinstance(key, type(slice(0))):
             val = self.__class__(val)
         return val
@@ -301,7 +298,7 @@ class Traceback(list):
             by default this removes all the TracebackEntries which are hidden
             (see ishidden() above)
         """
-        return Traceback(filter(fn, self))
+        return Traceback(list(filter(fn, self)))
 
     def getcrashentry(self):
         """ return last non-hidden traceback entry that lead
@@ -340,7 +337,7 @@ class Traceback(list):
 co_equal = compile('__recursioncache_locals_1 == __recursioncache_locals_2',
                    '?', 'eval')
 
-class ExceptionInfo(object):
+class ExceptionInfo:
     """ wraps sys.exc_info() objects and offers
         help for navigating the traceback.
     """
@@ -425,10 +422,10 @@ class ExceptionInfo(object):
     def __unicode__(self):
         entry = self.traceback[-1]
         loc = ReprFileLocation(entry.path, entry.lineno + 1, self.exconly())
-        return unicode(loc)
+        return str(loc)
 
 
-class FormattedExcinfo(object):
+class FormattedExcinfo:
     """ presenting information about failing Functions and Generators. """
     # for traceback entries
     flow_marker = ">"
@@ -703,7 +700,7 @@ class ReprEntry(TerminalRepr):
             self.reprfileloc.toterminal(tw)
 
     def __str__(self):
-        return "%s\n%s\n%s" % ("\n".join(self.lines),
+        return "{}\n{}\n{}".format("\n".join(self.lines),
                                self.reprlocals,
                                self.reprfileloc)
 
diff --git a/python/pytest/_pytest/_code/source.py b/python/pytest/_pytest/_code/source.py
index a1521f8a21..36ba5bc9d2 100644
--- a/python/pytest/_pytest/_code/source.py
+++ b/python/pytest/_pytest/_code/source.py
@@ -1,5 +1,3 @@
-from __future__ import generators
-
 from bisect import bisect_right
 import sys
 import inspect, tokenize
@@ -15,7 +13,7 @@ except ImportError:
     _ast = None
 
 
-class Source(object):
+class Source:
     """ a immutable object holding a source code fragment,
         possibly deindenting it.
     """
@@ -193,14 +191,13 @@ class Source(object):
             if flag & _AST_FLAG:
                 return co
             lines = [(x + "\n") for x in self.lines]
-            if sys.version_info[0] >= 3:
-                # XXX py3's inspect.getsourcefile() checks for a module
-                # and a pep302 __loader__ ... we don't have a module
-                # at code compile-time so we need to fake it here
-                m = ModuleType("_pycodecompile_pseudo_module")
-                py.std.inspect.modulesbyfile[filename] = None
-                py.std.sys.modules[None] = m
-                m.__loader__ = 1
+            # XXX py3's inspect.getsourcefile() checks for a module
+            # and a pep302 __loader__ ... we don't have a module
+            # at code compile-time so we need to fake it here
+            m = ModuleType("_pycodecompile_pseudo_module")
+            py.std.inspect.modulesbyfile[filename] = None
+            py.std.sys.modules[None] = m
+            m.__loader__ = 1
             py.std.linecache.cache[filename] = (1, None, lines, filename)
             return co
 
@@ -243,7 +240,7 @@ def getfslineno(obj):
         if fspath:
             try:
                 _, lineno = findsource(obj)
-            except IOError:
+            except OSError:
                 pass
     else:
         fspath = code.path
diff --git a/python/pytest/_pytest/assertion/__init__.py b/python/pytest/_pytest/assertion/__init__.py
index 6921deb2a6..67cefa8d07 100644
--- a/python/pytest/_pytest/assertion/__init__.py
+++ b/python/pytest/_pytest/assertion/__init__.py
@@ -70,7 +70,7 @@ def pytest_configure(config):
     warn_about_missing_assertion(mode)
     config._assertstate = AssertionState(config, mode)
     config._assertstate.hook = hook
-    config._assertstate.trace("configured with mode set to %r" % (mode,))
+    config._assertstate.trace("configured with mode set to {!r}".format(mode))
     def undo():
         hook = config._assertstate.hook
         if hook is not None and hook in sys.meta_path:
diff --git a/python/pytest/_pytest/assertion/reinterpret.py b/python/pytest/_pytest/assertion/reinterpret.py
index f4262c3ace..7615c1bcf7 100644
--- a/python/pytest/_pytest/assertion/reinterpret.py
+++ b/python/pytest/_pytest/assertion/reinterpret.py
@@ -49,8 +49,7 @@ class AssertionError(util.BuiltinAssertionError):
             if not self.args:
                 self.args = (self.msg,)
 
-if sys.version_info > (3, 0):
-    AssertionError.__module__ = "builtins"
+AssertionError.__module__ = "builtins"
 
 if sys.platform.startswith("java"):
     # See http://bugs.jython.org/issue1497
@@ -62,8 +61,8 @@ if sys.platform.startswith("java"):
               "AugAssign", "Print", "For", "While", "If", "With", "Raise",
               "TryExcept", "TryFinally", "Assert", "Import", "ImportFrom",
               "Exec", "Global", "Expr", "Pass", "Break", "Continue")
-    _expr_nodes = set(getattr(ast, name) for name in _exprs)
-    _stmt_nodes = set(getattr(ast, name) for name in _stmts)
+    _expr_nodes = {getattr(ast, name) for name in _exprs}
+    _stmt_nodes = {getattr(ast, name) for name in _stmts}
     def _is_ast_expr(node):
         return node.__class__ in _expr_nodes
     def _is_ast_stmt(node):
@@ -78,7 +77,7 @@ try:
     _Starred = ast.Starred
 except AttributeError:
     # Python 2. Define a dummy class so isinstance() will always be False.
-    class _Starred(object): pass
+    class _Starred: pass
 
 
 class Failure(Exception):
@@ -112,9 +111,9 @@ def getfailure(e):
     value = e.cause[1]
     if str(value):
         lines = explanation.split('\n')
-        lines[0] += "  << %s" % (value,)
+        lines[0] += "  << {}".format(value)
         explanation = '\n'.join(lines)
-    text = "%s: %s" % (e.cause[0].__name__, explanation)
+    text = "{}: {}".format(e.cause[0].__name__, explanation)
     if text.startswith('AssertionError: assert '):
         text = text[16:]
     return text
@@ -193,7 +192,7 @@ class DebugInterpreter(ast.NodeVisitor):
     def visit_Name(self, name):
         explanation, result = self.generic_visit(name)
         # See if the name is local.
-        source = "%r in locals() is not globals()" % (name.id,)
+        source = "{!r} in locals() is not globals()".format(name.id)
         co = self._compile(source)
         try:
             local = self.frame.eval(co)
@@ -210,9 +209,9 @@ class DebugInterpreter(ast.NodeVisitor):
         for op, next_op in zip(comp.ops, comp.comparators):
             next_explanation, next_result = self.visit(next_op)
             op_symbol = operator_map[op.__class__]
-            explanation = "%s %s %s" % (left_explanation, op_symbol,
+            explanation = "{} {} {}".format(left_explanation, op_symbol,
                                         next_explanation)
-            source = "__exprinfo_left %s __exprinfo_right" % (op_symbol,)
+            source = "__exprinfo_left {} __exprinfo_right".format(op_symbol)
             co = self._compile(source)
             try:
                 result = self.frame.eval(co, __exprinfo_left=left_result,
@@ -261,9 +260,9 @@ class DebugInterpreter(ast.NodeVisitor):
         left_explanation, left_result = self.visit(binop.left)
         right_explanation, right_result = self.visit(binop.right)
         symbol = operator_map[binop.op.__class__]
-        explanation = "(%s %s %s)" % (left_explanation, symbol,
+        explanation = "({} {} {})".format(left_explanation, symbol,
                                       right_explanation)
-        source = "__exprinfo_left %s __exprinfo_right" % (symbol,)
+        source = "__exprinfo_left {} __exprinfo_right".format(symbol)
         co = self._compile(source)
         try:
             result = self.frame.eval(co, __exprinfo_left=left_result,
@@ -282,24 +281,24 @@ class DebugInterpreter(ast.NodeVisitor):
             if isinstance(arg, _Starred):
                 arg_name = "__exprinfo_star"
                 ns[arg_name] = arg_result
-                arguments.append("*%s" % (arg_name,))
-                arg_explanations.append("*%s" % (arg_explanation,))
+                arguments.append("*{}".format(arg_name))
+                arg_explanations.append("*{}".format(arg_explanation))
             else:
-                arg_name = "__exprinfo_%s" % (len(ns),)
+                arg_name = "__exprinfo_{}".format(len(ns))
                 ns[arg_name] = arg_result
                 arguments.append(arg_name)
                 arg_explanations.append(arg_explanation)
         for keyword in call.keywords:
             arg_explanation, arg_result = self.visit(keyword.value)
             if keyword.arg:
-                arg_name = "__exprinfo_%s" % (len(ns),)
+                arg_name = "__exprinfo_{}".format(len(ns))
                 keyword_source = "%s=%%s" % (keyword.arg)
                 arguments.append(keyword_source % (arg_name,))
                 arg_explanations.append(keyword_source % (arg_explanation,))
             else:
                 arg_name = "__exprinfo_kwds"
-                arguments.append("**%s" % (arg_name,))
-                arg_explanations.append("**%s" % (arg_explanation,))
+                arguments.append("**{}".format(arg_name))
+                arg_explanations.append("**{}".format(arg_explanation))
 
             ns[arg_name] = arg_result
 
@@ -307,19 +306,19 @@ class DebugInterpreter(ast.NodeVisitor):
             arg_explanation, arg_result = self.visit(call.starargs)
             arg_name = "__exprinfo_star"
             ns[arg_name] = arg_result
-            arguments.append("*%s" % (arg_name,))
-            arg_explanations.append("*%s" % (arg_explanation,))
+            arguments.append("*{}".format(arg_name))
+            arg_explanations.append("*{}".format(arg_explanation))
 
         if getattr(call, 'kwargs', None):
             arg_explanation, arg_result = self.visit(call.kwargs)
             arg_name = "__exprinfo_kwds"
             ns[arg_name] = arg_result
-            arguments.append("**%s" % (arg_name,))
-            arg_explanations.append("**%s" % (arg_explanation,))
+            arguments.append("**{}".format(arg_name))
+            arg_explanations.append("**{}".format(arg_explanation))
         args_explained = ", ".join(arg_explanations)
-        explanation = "%s(%s)" % (func_explanation, args_explained)
+        explanation = "{}({})".format(func_explanation, args_explained)
         args = ", ".join(arguments)
-        source = "__exprinfo_func(%s)" % (args,)
+        source = "__exprinfo_func({})".format(args)
         co = self._compile(source)
         try:
             result = self.frame.eval(co, **ns)
@@ -343,8 +342,8 @@ class DebugInterpreter(ast.NodeVisitor):
         if not isinstance(attr.ctx, ast.Load):
             return self.generic_visit(attr)
         source_explanation, source_result = self.visit(attr.value)
-        explanation = "%s.%s" % (source_explanation, attr.attr)
-        source = "__exprinfo_expr.%s" % (attr.attr,)
+        explanation = "{}.{}".format(source_explanation, attr.attr)
+        source = "__exprinfo_expr.{}".format(attr.attr)
         co = self._compile(source)
         try:
             try:
@@ -357,12 +356,12 @@ class DebugInterpreter(ast.NodeVisitor):
                 co = self._compile(source)
                 class_name = self.frame.eval(co, __exprinfo_expr=source_result)
                 mangled_attr = "_" + class_name +  attr.attr
-                source = "__exprinfo_expr.%s" % (mangled_attr,)
+                source = "__exprinfo_expr.{}".format(mangled_attr)
                 co = self._compile(source)
                 result = self.frame.eval(co, __exprinfo_expr=source_result)
         except Exception:
             raise Failure(explanation)
-        explanation = "%s\n{%s = %s.%s\n}" % (self.frame.repr(result),
+        explanation = "{}\n{{{} = {}.{}\n}}".format(self.frame.repr(result),
                                               self.frame.repr(result),
                                               source_explanation, attr.attr)
         # Check if the attr is from an instance.
@@ -381,7 +380,7 @@ class DebugInterpreter(ast.NodeVisitor):
 
     def visit_Assert(self, assrt):
         test_explanation, test_result = self.visit(assrt.test)
-        explanation = "assert %s" % (test_explanation,)
+        explanation = "assert {}".format(test_explanation)
         if not self.frame.is_true(test_result):
             try:
                 raise util.BuiltinAssertionError
@@ -391,7 +390,7 @@ class DebugInterpreter(ast.NodeVisitor):
 
     def visit_Assign(self, assign):
         value_explanation, value_result = self.visit(assign.value)
-        explanation = "... = %s" % (value_explanation,)
+        explanation = "... = {}".format(value_explanation)
         name = ast.Name("__exprinfo_expr", ast.Load(),
                         lineno=assign.value.lineno,
                         col_offset=assign.value.col_offset)
diff --git a/python/pytest/_pytest/assertion/rewrite.py b/python/pytest/_pytest/assertion/rewrite.py
index 14b8e49db2..8275fe997e 100644
--- a/python/pytest/_pytest/assertion/rewrite.py
+++ b/python/pytest/_pytest/assertion/rewrite.py
@@ -26,7 +26,7 @@ else:
     else:
         impl = "cpython"
     ver = sys.version_info
-    PYTEST_TAG = "%s-%s%s-PYTEST" % (impl, ver[0], ver[1])
+    PYTEST_TAG = "{}-{}{}-PYTEST".format(impl, ver[0], ver[1])
     del ver, impl
 
 PYC_EXT = ".py" + (__debug__ and "c" or "o")
@@ -41,7 +41,7 @@ else:
     ast_Call = lambda a,b,c: ast.Call(a, b, c, None, None)
 
 
-class AssertionRewritingHook(object):
+class AssertionRewritingHook:
     """PEP302 Import hook which rewrites asserts."""
 
     def __init__(self):
@@ -95,7 +95,7 @@ class AssertionRewritingHook(object):
             try:
                 for pat in self.fnpats:
                     if fn_pypath.fnmatch(pat):
-                        state.trace("matched test file %r" % (fn,))
+                        state.trace("matched test file {!r}".format(fn))
                         break
                 else:
                     return None
@@ -139,7 +139,7 @@ class AssertionRewritingHook(object):
         # to check for a cached pyc. This may not be optimal...
         co = _read_pyc(fn_pypath, pyc, state.trace)
         if co is None:
-            state.trace("rewriting %r" % (fn,))
+            state.trace("rewriting {!r}".format(fn))
             source_stat, co = _rewrite_test(state, fn_pypath)
             if co is None:
                 # Probably a SyntaxError in the test.
@@ -147,7 +147,7 @@ class AssertionRewritingHook(object):
             if write:
                 _make_rewritten_pyc(state, source_stat, pyc, co)
         else:
-            state.trace("found cached rewritten pyc for %r" % (fn,))
+            state.trace("found cached rewritten pyc for {!r}".format(fn))
         self.modules[name] = co, pyc
         return self
 
@@ -218,7 +218,7 @@ def _write_pyc(state, co, source_stat, pyc):
     # the comment in load_module above.)
     try:
         fp = open(pyc, "wb")
-    except IOError:
+    except OSError:
         err = sys.exc_info()[1].errno
         state.trace("error writing pyc file at %s: errno=%s" %(pyc, err))
         # we ignore any failure to write the cache file
@@ -235,8 +235,8 @@ def _write_pyc(state, co, source_stat, pyc):
         fp.close()
     return True
 
-RN = "\r\n".encode("utf-8")
-N = "\n".encode("utf-8")
+RN = b"\r\n"
+N = b"\n"
 
 cookie_re = re.compile(r"^[ \t\f]*#.*coding[:=][ \t]*[-\w.]+")
 BOM_UTF8 = '\xef\xbb\xbf'
@@ -246,7 +246,7 @@ def _rewrite_test(state, fn):
     try:
         stat = fn.stat()
         source = fn.read("rb")
-    except EnvironmentError:
+    except OSError:
         return None, None
     if ASCII_IS_DEFAULT_ENCODING:
         # ASCII is the default encoding in Python 2. Without a coding
@@ -285,7 +285,7 @@ def _rewrite_test(state, fn):
         tree = ast.parse(source)
     except SyntaxError:
         # Let this pop up again in the real import.
-        state.trace("failed to parse: %r" % (fn,))
+        state.trace("failed to parse: {!r}".format(fn))
         return None, None
     rewrite_asserts(tree)
     try:
@@ -293,7 +293,7 @@ def _rewrite_test(state, fn):
     except SyntaxError:
         # It's possible that this error is from some bug in the
         # assertion rewriting, but I don't know of a fast way to tell.
-        state.trace("failed to compile: %r" % (fn,))
+        state.trace("failed to compile: {!r}".format(fn))
         return None, None
     return stat, co
 
@@ -317,15 +317,15 @@ def _read_pyc(source, pyc, trace=lambda x: None):
     """
     try:
         fp = open(pyc, "rb")
-    except IOError:
+    except OSError:
         return None
     with fp:
         try:
             mtime = int(source.mtime())
             size = source.size()
             data = fp.read(12)
-        except EnvironmentError as e:
-            trace('_read_pyc(%s): EnvironmentError %s' % (source, e))
+        except OSError as e:
+            trace('_read_pyc({}): EnvironmentError {}'.format(source, e))
             return None
         # Check for invalid or out of date pyc file.
         if (len(data) != 12 or data[:4] != imp.get_magic() or
@@ -335,7 +335,7 @@ def _read_pyc(source, pyc, trace=lambda x: None):
         try:
             co = marshal.load(fp)
         except Exception as e:
-            trace('_read_pyc(%s): marshal.load error %s' % (source, e))
+            trace('_read_pyc({}): marshal.load error {}'.format(source, e))
             return None
         if not isinstance(co, types.CodeType):
             trace('_read_pyc(%s): not a code object' % source)
@@ -408,7 +408,7 @@ def _format_boolop(explanations, is_or):
     return explanation.replace(t('%'), t('%%'))
 
 def _call_reprcompare(ops, results, expls, each_obj):
-    for i, res, expl in zip(range(len(ops)), results, expls):
+    for i, res, expl in zip(list(range(len(ops))), results, expls):
         try:
             done = not res
         except Exception:
@@ -695,10 +695,7 @@ class AssertionRewriter(ast.NodeVisitor):
         fmt = self.helper("format_explanation", msg)
         err_name = ast.Name("AssertionError", ast.Load())
         exc = ast_Call(err_name, [fmt], [])
-        if sys.version_info[0] >= 3:
-            raise_ = ast.Raise(exc, None)
-        else:
-            raise_ = ast.Raise(exc, None, None)
+        raise_ = ast.Raise(exc, None)
         body.append(raise_)
         # Clear temporary variables by setting them to None.
         if self.variables:
@@ -766,7 +763,7 @@ class AssertionRewriter(ast.NodeVisitor):
         symbol = binop_map[binop.op.__class__]
         left_expr, left_expl = self.visit(binop.left)
         right_expr, right_expl = self.visit(binop.right)
-        explanation = "(%s %s %s)" % (left_expl, symbol, right_expl)
+        explanation = "({} {} {})".format(left_expl, symbol, right_expl)
         res = self.assign(ast.BinOp(left_expr, binop.op, right_expr))
         return res, explanation
 
@@ -790,11 +787,11 @@ class AssertionRewriter(ast.NodeVisitor):
             else: ## **args have `arg` keywords with an .arg of None
                 arg_expls.append("**" + expl)
 
-        expl = "%s(%s)" % (func_expl, ', '.join(arg_expls))
+        expl = "{}({})".format(func_expl, ', '.join(arg_expls))
         new_call = ast.Call(new_func, new_args, new_kwargs)
         res = self.assign(new_call)
         res_expl = self.explanation_param(self.display(res))
-        outer_expl = "%s\n{%s = %s\n}" % (res_expl, res_expl, expl)
+        outer_expl = "{}\n{{{} = {}\n}}".format(res_expl, res_expl, expl)
         return res, outer_expl
 
     def visit_Starred(self, starred):
@@ -825,12 +822,12 @@ class AssertionRewriter(ast.NodeVisitor):
         if call.kwargs:
             new_kwarg, expl = self.visit(call.kwargs)
             arg_expls.append("**" + expl)
-        expl = "%s(%s)" % (func_expl, ', '.join(arg_expls))
+        expl = "{}({})".format(func_expl, ', '.join(arg_expls))
         new_call = ast.Call(new_func, new_args, new_kwargs,
                             new_star, new_kwarg)
         res = self.assign(new_call)
         res_expl = self.explanation_param(self.display(res))
-        outer_expl = "%s\n{%s = %s\n}" % (res_expl, res_expl, expl)
+        outer_expl = "{}\n{{{} = {}\n}}".format(res_expl, res_expl, expl)
         return res, outer_expl
 
     # ast.Call signature changed on 3.5,
@@ -858,7 +855,7 @@ class AssertionRewriter(ast.NodeVisitor):
         res_variables = [self.variable() for i in range(len(comp.ops))]
         load_names = [ast.Name(v, ast.Load()) for v in res_variables]
         store_names = [ast.Name(v, ast.Store()) for v in res_variables]
-        it = zip(range(len(comp.ops)), comp.ops, comp.comparators)
+        it = list(zip(list(range(len(comp.ops))), comp.ops, comp.comparators))
         expls = []
         syms = []
         results = [left_res]
@@ -867,7 +864,7 @@ class AssertionRewriter(ast.NodeVisitor):
             results.append(next_res)
             sym = binop_map[op.__class__]
             syms.append(ast.Str(sym))
-            expl = "%s %s %s" % (left_expl, sym, next_expl)
+            expl = "{} {} {}".format(left_expl, sym, next_expl)
             expls.append(ast.Str(expl))
             res_expr = ast.Compare(left_res, [op], [next_res])
             self.statements.append(ast.Assign([store_names[i]], res_expr))
